#!/usr/bin/perl -w

# Copyright 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyR5Dragon;
use MyPrintwrap ':all';

# uncomment this to run the ### lines
# use Smart::Comments;


my $level = 4;
if (@ARGV) { $level = shift @ARGV; }

print "% generated by tools/$FindBin::Script $level\n";

my $var = 'gen';

my $graph = MyR5Dragon::r5quad_area_tree_Graph($level);
my @pending = ($graph->get_graph_attribute ('root_vertex'));
my @QAwidth;
my %seen;
my $d = 0;
while (@pending) {
  ### at: join(' ',@pending)
  $QAwidth[$d] = scalar(@pending);
  @seen{@pending} = (); # hash slice
  @pending = grep {! exists $seen{$_}} map {$graph->neighbours($_)} @pending;
  $d++;
}

printwrap_indent("% GP-DEFINE  ");
printwrap("gen_QAwidth_samples = {[");
$Printwrap = 2;
foreach my $i (0 .. $#QAwidth) {
  printwrap("$QAwidth[$i]" . ($i==$#QAwidth ? '' : ','));
}
$Printwrap = 0;
printwrap("]};\n");

print "% end generated\n";
exit 0;
