#!/usr/bin/perl -w

# Copyright 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyR5Dragon ':all';
use MyPrintwrap ':all';


print "  % generated by tools/$FindBin::Script\n";

my $s = 3;

foreach my $i (0 .. $s) {
  $Printwrap = 2;
  printwrap("\\draw (0-\\MyEdge,$i)--($s+\\MyEdge,$i) ($i,0-\\MyEdge)--($i,$s+\\MyEdge);\n");

  # dots
  foreach my $j (0 .. $s) {
    printwrap(" \\fill ($i,$j)circle;");
  }
  printwrap_newline();
}

print "  \\begin{scope}[shift=(right-pos)]\n";

# real(1/(2+I)) == 2/5
# imag(1/(2+I)) == -1/5
# real((1+I)/(2+I)) == 3/5
# imag((1+I)/(2+I)) == 1/5
# real((2+I)/(2+I))
# imag((2+I)/(2+I))
#

{
  $Printwrap = 4;
  printwrap(" \\draw[my inner]");
  $Printwrap += 2;
  my $join = '';
  foreach my $i (0 .. $s-1) {
    foreach my $j (0 .. $s-1) {
      printwrap($join);
      printwrap(" ($i+.6,$j+.2)");
      printwrap("--($i+.8,$j+.6)");
      printwrap("--($i+.4,$j+.8)");
      printwrap("--($i+.2,$j+.4)");
      printwrap("--cycle");
      $join = "\n";
    }
  }
  printwrap(";\n");
}

foreach my $i (0 .. $s) {
  $Printwrap = 4;
  foreach my $j (0 .. $s) {
    printwrap(" \\fill ($i,$j)circle;");
  }
  printwrap_newline();
}

{
  $Printwrap = 4;
  printwrap("\\draw");
  $Printwrap += 2;
  foreach my $i (0 .. $s) {
    printwrap(" (-2*\\MyEdgeExp, $i+\\MyEdgeExp)");
    my $join = '';
    foreach my $j (0 .. $s-1) {
      printwrap("--($j+.4, $i-.2)");
      printwrap("--($j+.6, $i+.2)");
      $join = '--';
    }
    printwrap("--($s+2*\\MyEdgeExp, $i-\\MyEdgeExp)");
  }
  foreach my $i (0 .. $s) {
    printwrap(" ($i-\\MyEdgeExp, -2*\\MyEdgeExp)");
    my $join = '';
    foreach my $j (0 .. $s-1) {
      my $end = ($j == $s-1 ? ';' : '');
      printwrap("--($i+.2, $j+.4)");
      printwrap("--($i-.2, $j+.6)");
      $join = '--';
    }
    printwrap("--($i+\\MyEdgeExp, $s+2*\\MyEdgeExp)");
  }
  printwrap(";\n");
}
print "  \\end{scope}\n";

print "  % end generated\n";
exit 0;
